#pragma inline
/*******************************************************************************
*  Calculate Pi to an arbitrary precision                                      *
*                                                                              *
*  (C) by Juergen Bohl 1995      (email: bohl@pc.chemie.th-darmstadt.de)       *
*                                                                              *
* usage : pi <precision>                                                       *
*                                                                              *
* if <precision> < 0 , Machin's formula is used, Gauss' formula otherwise      *
*                                                                              *
* compiled with Borland C++ 2.0 for OS/2                                       *
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <mem.h>

typedef int BOOL;
#define TRUE	(1)
#define FALSE 	(0)
#define billion (1000*1000*1000)
#define billionminuseins ((1000*1000*1000)-1)

char* calc_pi(int digits,BOOL gauss=FALSE);
BOOL division(int* array,int divisor,int arraysize);
BOOL division(int* arraydest,int* arraysour,int divisor,int arraysize);
void addition(int* sum,int* array,int arraysize);
void subtraktion(int* diff,int* array,int arraysize);
char* makestring(int* array,int arraysize);
void print(int* array,int arraysize);


int main(int argc,char** argv)
{
int digits;
BOOL gauss=TRUE;
if (argc < 2)
	{
	digits=100;
	}
else
	{
	digits=atoi(*(argv+1));
	if (digits<=0)
		{
		gauss=FALSE;
		digits*=-1;
		};
	};
digits = digits/9 +1;
char* cp;
cp=calc_pi(digits*9,gauss);
fprintf(stdout,"3.%s \n",cp);
free(cp);
return EXIT_SUCCESS;
};

char* calc_pi(int digits,BOOL gauss)
{
int arraysize;
int* array1,*array2,*result;
char* r;
int count,power;
BOOL notready,add;

arraysize = (digits/9+1);

array1 = (int*)malloc(arraysize*sizeof(int));
array2 = (int*)malloc(arraysize*sizeof(int));
result = (int*)malloc(arraysize*sizeof(int));

memset(array1,0,arraysize*sizeof(int));
memset(array2,0,arraysize*sizeof(int));
memset(result,0,arraysize*sizeof(int));
array1[arraysize-1]=1;
if (gauss==FALSE)
	{
	printf("Formel von Machin :\n");
	count=1;
	power=5;
	notready=TRUE;
	add=TRUE;
	division(array1,power,arraysize);
	while (notready)
		{
		notready = division(array2,array1,count,arraysize);
		if (add==TRUE)
			{
			addition(result,array2,arraysize);
			add=FALSE;
			}
		else
			{
			subtraktion(result,array2,arraysize);
			add=TRUE;
			};
		count+=2;
		division(array1,power*power,arraysize);
		};
	addition(result,result,arraysize);
	addition(result,result,arraysize);

	memset(array1,0,arraysize*sizeof(int));
	memset(array2,0,arraysize*sizeof(int));
	array1[arraysize-1]=1;

	power=239;
	count=1;
	add=FALSE;
	notready=TRUE;
	division(array1,power,arraysize);

	while (notready)
		{
		notready = division(array2,array1,count,arraysize);
		if (add)
			{
			addition(result,array2,arraysize);
			add=FALSE;
			}
		else
			{
			subtraktion(result,array2,arraysize);
			add=TRUE;
			};
		count+=2;
		division(array1,power*power,arraysize);
		};
	addition(result,result,arraysize);
	addition(result,result,arraysize);
	}
else
	{
	printf("Formel von Gauss :\n");
	count=1;
	power=18;
	notready=TRUE;
	add=TRUE;
	division(array1,power,arraysize);
	while (notready)
		{
		notready = division(array2,array1,count,arraysize);
		if (add==TRUE)
			{
			addition(result,array2,arraysize);
			add=FALSE;
			}
		else
			{
			subtraktion(result,array2,arraysize);
			add=TRUE;
			};
		count+=2;
		division(array1,power*power,arraysize);
		};
	// ergebnis * 12
	addition(result,result,arraysize);	// *2
	addition(result,result,arraysize);	// *4
	memcpy(array1,result,arraysize*sizeof(int));
	addition(result,result,arraysize);	// *8
	addition(result,array1,arraysize);

	memset(array1,0,arraysize*sizeof(int));
	memset(array2,0,arraysize*sizeof(int));
	array1[arraysize-1]=1;

	int* result2;
	result2 = (int*)malloc(arraysize*sizeof(int));
	memset(result2,0,arraysize*sizeof(int));
	power=57;
	count=1;
	add=TRUE;
	notready=TRUE;
	division(array1,power,arraysize);

	while (notready)
		{
		notready = division(array2,array1,count,arraysize);
		if (add)
			{
			addition(result2,array2,arraysize);
			add=FALSE;
			}
		else
			{
			subtraktion(result2,array2,arraysize);
			add=TRUE;
			};
		count+=2;
		division(array1,power*power,arraysize);
		};
	addition(result2,result2,arraysize);	// *2
	addition(result2,result2,arraysize);	// *4
	addition(result2,result2,arraysize);	// *8

	addition(result,result2,arraysize);

	memset(result2,0,arraysize*sizeof(int));
	memset(array1,0,arraysize*sizeof(int));
	memset(array2,0,arraysize*sizeof(int));
	array1[arraysize-1]=1;

	power=239;
	count=1;
	add=FALSE;
	notready=TRUE;
	division(array1,power,arraysize);

	while (notready)
		{
		notready = division(array2,array1,count,arraysize);
		if (add)
			{
			addition(result2,array2,arraysize);
			add=FALSE;
			}
		else
			{
			subtraktion(result2,array2,arraysize);
			add=TRUE;
			};
		count+=2;
		division(array1,power*power,arraysize);
		};
	memcpy(array1,result2,arraysize*sizeof(int));
	addition(result2,result2,arraysize);	// *2
	addition(result2,result2,arraysize);	// *4
	addition(result2,array1,arraysize);	// *5

	addition(result,result2,arraysize);
	free(result2);
	addition(result,result,arraysize);
	addition(result,result,arraysize);
	};


free(array1);free(array2);
r = makestring(result,arraysize);
free(result);
return r;
};

BOOL division(int* array,int divisor,int arraysize)
{
long temp;
asm {
mov esi,divisor
mov eax,arraysize
mov edi,array
sub eax,1
mov ebx,4
mul ebx
add edi,eax
mov temp,FALSE
mov ecx,0
}
loop:
asm {
cmp edi,array
jb ende
mov eax,billion
mul ecx
mov ebx, [edi]
add eax,ebx
jnc _nocarry
inc edx
}
_nocarry:
asm {

div esi
mov DWORD PTR [edi],eax
mov ecx,edx
sub edi,4
cmp eax,0
je loop
mov temp,TRUE
jmp loop
}
ende:
return temp;
};

BOOL division(int* arraydest,int* arraysour,int divisor,int arraysize)
{
long temp;
asm {
mov esi,arraydest
mov eax,arraysize
mov edi,arraysour
sub eax,1
mov ebx,4
mul ebx
add edi,eax
add esi,eax
mov temp,FALSE
mov ecx,0
}
loop:
asm {
cmp edi,arraysour
jb ende
mov eax,billion
mul ecx
mov ebx, [edi]
add eax,ebx
jnc _nocarry
inc edx
}
_nocarry:
asm {
div divisor
mov DWORD PTR [esi],eax
mov ecx,edx
sub edi,4
sub esi,4
cmp eax,0
je loop
mov temp,TRUE
jmp loop
}
ende:
return temp;
};


void addition(int* sum,int* array,int arraysize)
{
asm	{
mov esi,sum
mov edi,array
mov eax,0
mov edx,0
}
loop:
asm {
mov ecx,dword ptr [edi]
add dword ptr [esi],ecx
add [esi],edx
mov edx,0
cmp [esi], billionminuseins
jng no_greater
sub [esi],billion
mov edx,1
}
no_greater:
asm {
add esi,4
add edi,4
inc eax
cmp eax,arraysize
je ende
jmp loop
}
ende:
return;
};

void subtraktion(int* diff,int* array,int arraysize)
{
asm {
mov eax,arraysize
mov esi,array
mov edi,billionminuseins
}
loop:
asm {
mov ebx,edi
mov edx,[esi]
sub ebx,edx
mov [esi],ebx
add esi,4
dec eax
je ende
jmp loop
}

ende:
asm
{
mov eax,arraysize
mov esi,array
mov edx,1
}
loop2:
asm {
mov ecx,[esi]
add ecx,edx
mov [esi],ecx
cmp ecx,billionminuseins
jng ende2
sub ecx,billion
mov [esi],ecx
add esi,4
jmp loop2
}
ende2:
addition(diff,array,arraysize);
};

char* makestring(int* array,int arraysize)
{
int i,j,x;
char* string,*cp;
string = (char*)malloc(arraysize*sizeof(char)*9+10);
cp = string;
for ( i = arraysize-2; i>=0; i--)
	{
	x=array[i];
	for (j=0;j<9;j++)
		{
		string[8-j]=(x%10)+'0';
		x/=10;
		};
	string+=9;
	};
*(string+10)='\0';
return cp;
};


void print(int* array,int arraysize)
{
char* cp;
cp = makestring( array,arraysize);
printf("%s\n",cp);
free(cp);
return;
};
